// Share Library Test
// This is the shared library header

#ifndef __PLUGLIB_H__
#define __PLUGLIB_H__

#ifndef PLUGIN_TRAP
#define PLUGIN_TRAP(trapno)   SYS_TRAP(trapno)
#endif

struct data_source;
struct grid_data;

// Library reference returned by SysLibFind() or SysLibLoad()
extern UInt16 PlugLibRef;

// Values for use with SysLibLoad()
#define LibType		'libr'
#define PlugLibCreator	'DBOS'
#define PlugLibVersion 3

/**************************
 * Library interface data *
 **************************/
typedef enum {
    NoAction = 0,
    RunAtListView = 1,
    RunAtEditView,
    RunAtChooser,
    AutoRunAtListViewOpen = 11,
    AutoRunAtEditViewOpen,
    AutoRunAtChooserOpen,
    AutoRunAtListViewClose = 21,
    AutoRunAtEditViewClose,
    AutoRunAtChooserClose,
    RunAtCategoryChanged = 50
} PlugLib_actionID;

#define AutoRunAtListView AutoRunAtListViewOpen
#define AutoRunAtEditView AutoRunAtEditViewOpen
#define AutoRunAtChooser AutoRunAtChooserOpen

typedef struct {
    struct data_source *source;
    UInt16 record;
    struct data_source_driver *driverlist;
    void *appliDataV2; /* use for a next version */
} PlugLib_appliDataV1;

/*****************************
 * Library control functions *
 *****************************/
Err PlugLibOpen(UInt16 refNum) PLUGIN_TRAP(sysLibTrapOpen);
Err PlugLibClose(UInt16 refNum, UInt16 * numappsP) PLUGIN_TRAP(sysLibTrapClose);
Err PlugLibSleep(UInt16 refNum) PLUGIN_TRAP(sysLibTrapSleep);
Err PlugLibWake(UInt16 refNum) PLUGIN_TRAP(sysLibTrapWake);
UInt32 PlugLib_getVersion(UInt16 refnum) PLUGIN_TRAP(sysLibTrapCustom);
void PlugLib_showAboutBox(UInt16 refnum) PLUGIN_TRAP(sysLibTrapCustom+1);
struct data_source_driver * PlugLib_getDriver(UInt16 refnum) PLUGIN_TRAP(sysLibTrapCustom+2);
void * PlugLib_getAction(UInt16 refnum, UInt16) PLUGIN_TRAP(sysLibTrapCustom+3);
struct grid_data * PlugLib_getGrid(UInt16 refnum) PLUGIN_TRAP(sysLibTrapCustom+4);

/*************************
 * Library internal data *
 *************************/
typedef struct {
    PlugLib_actionID actionID;
    void *function;
} PlugLib_action;

typedef struct {
    UInt16 refcount;
    struct data_source_driver *driver;
    UInt16 aboutAlertID;
    UInt16 numActions;
    PlugLib_action actions[10];
} PlugLib_globals;


#endif
