#include <PalmOS.h>

#include "db.h"
#include "enum.h"
#include "PlugLib.h"
#include "uninstallrsc.h"
#include "prefs.h"

UInt32
PilotMain(UInt16 cmd, void * cmdPBP, UInt16 launchFlags)
{
    switch (cmd){
    case sysAppLaunchCmdNormalLaunch:
        if ( FrmAlert(alertID_DeletePilotDB) == 0){
            UInt16 cardNo;
            LocalID dbID;
            DmSearchStateType searchState;
            Boolean newSearch = true;
            UInt32 type = 'appl';
            UInt32 creator = DBCreatorID;

            //delete the main application
            while (DmGetNextDatabaseByTypeCreator( newSearch, &searchState, 
                            type, creator, false, &cardNo, &dbID) == errNone) {
                newSearch = false;
                DmDeleteDatabase(cardNo, dbID);
            }

            //delete the tmp database if it exists.
            dbID = DmFindDatabase(cardNo, TMPDatabase);
            if (dbID)
                DmDeleteDatabase(cardNo, dbID);

            //delete the plugins
            newSearch = true;
            creator = PlugLibCreator;
            type = LibType;
            while (DmGetNextDatabaseByTypeCreator( newSearch, &searchState, 
                            type, creator, false, &cardNo, &dbID) == errNone) {
                newSearch = false;
                DmDeleteDatabase(cardNo, dbID);
            }

            //delete the overlay
            newSearch = true;
            creator = DBCreatorID;
            type = DBOverlayTypeID;
            while (DmGetNextDatabaseByTypeCreator( newSearch, &searchState, 
                            type, creator, false, &cardNo, &dbID) == errNone) {
                newSearch = false;
                DmDeleteDatabase(cardNo, dbID);
            }

            //delete the databases list
            newSearch = true;
            creator = DBCreatorID;
            type = DBListTypeID;
            while (DmGetNextDatabaseByTypeCreator( newSearch, &searchState, 
                            type, creator, false, &cardNo, &dbID) == errNone) {
                newSearch = false;
                DmDeleteDatabase(cardNo, dbID);
            }

            PrefSetAppPreferences(DBCreatorID, prefID_GlobalPrefs, 0,
                                  0, 0, false);
            PrefSetAppPreferences(DBCreatorID, prefID_LastDataSource, 0,
                              0, 0, false);
        }
    break;
    default:
    }
    return 0;
}
