#ifndef __UTIL_H__
#define __UTIL_H__


#define YMD 0
#define DMY 1
#define MDY 2

typedef struct localization_info_struct {
  
  Char decimalChar;
  Char dateChar;
  UInt8 dateOrder;

} LocalizationInfo;

extern LocalizationInfo LocalInfo;

extern void * ShowModalMessage(const char *, FontID, FrameType) SECT_UI2;
extern void   HideModalMessage(void * ptr) SECT_UI2;
extern void * ShowWorkingIndicator(void) SECT_UI2;
extern void   HideWorkingIndicator(void *) SECT_UI2;
extern void   UtilWinDrawTruncChars(const char * str, UInt16 length,
				Int16 x, Int16 y, Int16 maxWidth, Boolean ljustify) SECT_UI2;

#ifndef SetBits
#define SetBits( b, len )      ( ( ( 1U << ( ( len ) - 1 ) ) - 1U + ( 1U << ( ( len ) - 1 ) ) ) << ( b ) )
#endif

//pinMaxConstraintSize is set to the max value of a Coord such that it can grow as big as the 
//hardware supports
#ifndef pinMaxConstraintSize
#define pinMaxConstraintSize 	SetBits( 0, ( sizeof( Coord) * 8 ) - 1 )
#endif
extern void UtilPreprocessEvent(EventType *eventP) SECT_UI2;
extern Boolean UtilMoveResizeForm(FormPtr form, Coord *x_diff, Coord *y_diff, Boolean draw) SECT_UI2;
extern void UtilMoveObject(FormPtr frmP, UInt16 objIndex, Coord x_diff, Coord y_diff, Boolean draw) SECT_UI2;
extern void UtilResizeObject(FormPtr frmP, UInt16 objIndex, Coord x_diff, Coord y_diff, Boolean draw) SECT_UI2;
extern Boolean UtilCenterForm(FormPtr form, Boolean draw) SECT_UI2;
extern Boolean UtilCheckSizeForm(FormPtr form, Boolean draw) SECT_UI2;


extern Boolean UtilRctPtInRectangle( Int16 x, Int16 y, RectangleType *r) SECT_UI2;

#ifndef __PLUGIN__
extern void Localize() SECT_UI2;
extern Boolean IsInt( char *str )  SECT_UI2;
extern Boolean IsFloat( char *str ) SECT_UI2;
extern Boolean IsDate( char *str, Date *d ) SECT_UI2;
extern Boolean IsTime( char *str, Time *t ) SECT_UI2;

#endif




/*  ----------------------- SONY HI RES SUPPORT MACROS -------------------- */


#ifdef CONFIG_SONY
#define UtlWinScrollRectangle(r,d,l,v) { \
   if ( FeatureSetSony && SonyLibRefNum ) { \
	   HRWinScrollRectangle(SonyLibRefNum,(r),(d),(l),(v)); \
   } else \
      WinScrollRectangle((r),(d),(l),(v)); }

#else 
#define UtlWinScrollRectangle(r,d,l,v) \
   WinScrollRectangle((r),(d),(l),(v)) 
#endif

#ifdef CONFIG_SONY
#define UtlWinPaintRectangle(r,c) { \
   if ( FeatureSetSony && SonyLibRefNum ) { \
	   HRWinPaintRectangle(SonyLibRefNum,(r),(c)); \
   } else \
      WinPaintRectangle((r),(c)); }

#else 
#define UtlWinPaintRectangle(r,c) \
   WinPaintRectangle((r),(c)) 
#endif

#ifdef CONFIG_SONY
#define UtlWinCopyRectangle(w,n,r,x,y,m) { \
   if ( FeatureSetSony && SonyLibRefNum ) { \
	   HRWinCopyRectangle(SonyLibRefNum,(w),(n),(r),(x),(y),(m)); \
   } else \
      WinCopyRectangle((w),(n),(r),(x),(y),(m)); }

#else 
#define UtlWinCopyRectangle(w,n,r,x,y,m)  \
      WinCopyRectangle((w),(n),(r),(x),(y),(m))
#endif

#ifdef CONFIG_SONY
#define UtlWinEraseRectangle(r,m) { \
   if ( FeatureSetSony && SonyLibRefNum ) { \
	   HRWinEraseRectangle(SonyLibRefNum,(r),(m)); \
   } else \
      WinEraseRectangle((r),(m)); }

#else 
#define UtlWinEraseRectangle(r,m)  \
      WinEraseRectangle((r),(m))
#endif




#endif
